// Unreal Fighting Framework by Kevin Poretti

#include "FFState.h"

// FF includes
#include "FFStateMachineComponent.h"


void UFFStateBehavior::Enter(const FFFStateContext& InStateContext)
{
    OnEnter(InStateContext);
}


void UFFStateBehavior::Exit(const FFFStateContext& InStateContext)
{
    OnExit(InStateContext);
}


void UFFStateBehavior::Update(float OneFrame, const FFFStateContext& InStateContext)
{
    OnUpdate(OneFrame, InStateContext);
}

void UFFStateBehavior::OnLanded_Implementation(const FFFStateContext& InStateContext)
{
}


void UFFStateBehavior::OnEnter_Implementation(const FFFStateContext& InStateContext)
{
}


void UFFStateBehavior::OnExit_Implementation(const FFFStateContext& InStateContext)
{
}


void UFFStateBehavior::OnUpdate_Implementation(float OneFrame, const FFFStateContext& InStateContext)
{
}


void UFFStateBehavior::OnHit_Implementation(const FFFStateContext& InStateContext)
{
}


void UFFStateBehavior::OnBlock_Implementation(const FFFStateContext& InStateContext)
{
}


void UFFStateBehavior::OnInputEvent_Implementation(const FFFStateContext& InStateContext)
{
}


UWorld* UFFStateBehavior::GetWorld() const
{
	UFFStateMachineComponent* SMC = Cast<UFFStateMachineComponent>(GetOuter());
	if(SMC)
	{
		return SMC->GetWorld();
	}
	
	return nullptr;
}
