// Unreal Fighting Framework by Kevin Poretti

#pragma once

#include "CoreMinimal.h"
#include "UObject/Interface.h"

#include "FFStateContextInterface.generated.h"

UINTERFACE(MinimalAPI)
class UFFStateContextInterface : public UInterface
{
	GENERATED_BODY()
};

/**
 * 
 */
class UNREALFIGHTINGFRAMEWORK_API IFFStateContextInterface
{
	GENERATED_BODY()

public:
	virtual bool CheckStateEnabled(uint8 StateType) = 0;

	virtual bool CheckStance(uint8 Stance) = 0;

	virtual bool CheckStateEntryConditions(const TArray<uint8>& EntryConditions) = 0;

	virtual bool CheckInputSequences(const TArray<FFFInputSequence>& InputSequences) = 0;
};
